# Shift 8 decimal places
def decimalize(str):
    return float(str) / 100000000

import pprint
def pretty_print(obj):
    pp = pprint.PrettyPrinter(indent=4)
    pp.pprint(obj)

import networkx as nx
from collections import deque, defaultdict
# Modified from networkx
def bfs(G, source, reverse=False):
    """Produce edges in a breadth-first-search starting at source."""
    # Based on http://www.ics.uci.edu/~eppstein/PADS/BFS.py
    # by D. Eppstein, July 2004.
    if reverse and isinstance(G, nx.DiGraph):
        neighbors = G.predecessors_iter
    else:
        neighbors = G.neighbors_iter
    visited=set([source])
    queue = deque([(source, neighbors(source))])
    visited_count=defaultdict(int)
    while queue:
        parent, children = queue[0]
        try:
            child = next(children)
            if child not in visited:
                yield parent, child
                visited.add(child)
                queue.append((child, neighbors(child)))
            else:
                visited_count[child] += 1
        except StopIteration:
            queue.popleft()

    doop = [(addr,count) for addr,count in visited_count.items() if count >= 3]
    pretty_print(doop)
    print len(doop)

def bfs_tree(G, source, reverse=False):
    """Return directed tree of breadth-first-search from source."""
    T = nx.DiGraph()
    T.add_node(source)
    T.add_edges_from(bfs(G,source,reverse=reverse))
    return T

# Compare a distribution to Benford's law and give a statistical score
def benford_law(distribution):
    # Benford's digit distribution - hardcode
    z = [.301, .176, .125, .097, .079, .067, .058, .051, .046]
    pass
